VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BgsBrowseFFolder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' *********************************************************************
'  Titolo: BGSBrowseForFolder
'* CLASS Classe per utilizzare la ricerca per cartelle.
'* <BR>Autore: <B>Giorgio Bernardi</B>
'* E-Mail: <A HREF="mailto:BGSoftware@hotmail.com">BGSoftware@hotmail.com</A>
'* Web: <A HREF="http://Giorgio_Bernardi.tripod.com/">http://Giorgio_Bernardi.tripod.com</A>
'* Data  : Novembre 2000
'* Info :Potete usare e modificare a piacimento questo codice.
'* <BR><BR>Le Istruzioni sono state ispirate da AdvanceBrowseForFolder _
By Mauro Rossi. Web: <A HREF="http://www.mauro.sistel.it/">http://www.mauro.sistel.it/</A>.
' *********************************************************************

Option Explicit
'**************************************************************************
'VARIABILI E OGGETTI SFRUTTATI  (API, TIPI, ECC...)
'**************************************************************************

'* Tipo per il Browser
Private Type BROWSEINFO
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type

Private Type SHITEMID
    cb As Long
    abID As Byte
End Type

Private Type ITEMIDLIST
    mkid As SHITEMID
End Type

'* Cartelle Base Da cui far Partire l'albero
Public Enum BaseFoldersForBrowsing
    Default = -1
    Desktop
    InternetExplorer
    Programmi
    PannelloDiControllo
    Stampanti
    Documenti
    preferiti
    EsecuzioneAutomatica
    Recenti
    InviaA
    Cestino
    MenuAvvio
    NON_USATO
    NON_USATO2
    Video
    NON_USATO3
    DesktopFolder
    RisorseComputer
    Rete
    RisorseDiRete
    Fonts
    ShellNew
End Enum

'* Api di Windows
Private Declare Function SHBrowseForFolder Lib "shell32.dll" (lpbi As BROWSEINFO) As Long
'* Api di Windows
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
'* Api di Windows
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long

Private Const WM_USER = &H400&

'Flags Possibili da passare
Private Const BIF_RETURNONLYFSDIRS = &H1&       '* For finding a folder to start document searching
'Public Const BIF_DONTGOBELOWDOMAIN = &H2&      '// For starting the Find Computer
'Public Const BIF_STATUSTEXT = &H4&
'Public Const BIF_RETURNFSANCESTORS = &H8&
'Public Const BIF_EDITBOX = &H10&
'Public Const BIF_VALIDATE = &H20&              'insist on valid result (or CANCEL)
'Public Const BIF_BROWSEFORCOMPUTER = &H1000&   'Ricerca Computers
'Public Const BIF_BROWSEFORPRINTER = &H2000&    'Ricerca Stampanti
Private Const BIF_BROWSEINCLUDEFILES = &H4000&   '* Aggiunge La possibilit di selezionare files

'**************************************************************************
'VARIABILI PUBBLICHE DELL'OGGETTO
'**************************************************************************

Public DialogTitle As String        '* Il titolo della finestra
Public fileName As String           '* Ultimo File Aperto
Public Folder As String             '* Ultima Cartella Aperta
Public ViewTreeFrom As BaseFoldersForBrowsing   '* Limitazione dell'albero
Public ViewFiles As Boolean         '* Imposta la visualizzazione dei files

'**************************************************************************
'FUNZIONE DA RICHIAMARE
'**************************************************************************

'* Questa funzione deve essere chiamata passando l'Handle della finestra _
dalla quale si chiama la finestra di dialogo.
Public Function ShowFolders(hWnd As Long) As String
Dim Flgs As Long            'Imposto Le Flags
Dim TempResult As String    'Risultato della Chiamata
Dim MyBrowse As BROWSEINFO      'E' il "Browser" che uso

    Flgs = BIF_RETURNONLYFSDIRS
    If ViewFiles Then Flgs = Flgs Or BIF_BROWSEINCLUDEFILES

    'Handle del richiedente
    MyBrowse.hOwner = hWnd
    
    'Impostazione della Limitazione (Base dell'albero delle directory)
    If ViewTreeFrom > Default Then
        Dim MyItem As ITEMIDLIST
        Call SHGetSpecialFolderLocation(ByVal hWnd, ByVal ViewTreeFrom, MyItem)
        MyBrowse.pidlRoot = MyItem.mkid.cb
    End If
    
    'Indicazione della Richiesta (titolo)
    MyBrowse.lpszTitle = DialogTitle
    
    'Impostazione delle Flags
    MyBrowse.ulFlags = Flgs
    
    '  Visualizza la finestra Browse for Folder
    Dim BrowseResult As Long
    BrowseResult = SHBrowseForFolder(MyBrowse)
    
    'Restituzione del valore ottenuto
    Dim BrowsePath As String    'Buffer
    Dim Chr0 As Long            'Posizione del carattere 0
    
    BrowsePath = Space$(512)
    If SHGetPathFromIDList(ByVal BrowseResult, ByVal BrowsePath) Then
        Chr0 = InStr(BrowsePath, Chr$(0))
        TempResult = Left(BrowsePath, Chr0 - 1)
        
        'Ulteriore Gestione del risultato
        If Len(TempResult) < 4 Then 'E una Base di un disco
                Folder = TempResult
        Else
            If (GetAttr(TempResult) And vbDirectory) = vbDirectory Then
                If Right(TempResult, 1) <> "\" Then TempResult = TempResult & "\"
                Folder = TempResult
            Else
                Folder = getFilePath(TempResult)
                fileName = TempResult
            End If
        End If
    Else    'Tasto Annulla Premuto
        TempResult = ""
    End If

ShowFolders = TempResult
End Function

Private Sub Class_Initialize()
'Inizializzazione della classe
DialogTitle = "Scegli La Cartella..."
fileName = ""
Folder = ""
ViewTreeFrom = Default
ViewFiles = False
End Sub

'**************************************************************************
'FUNZIONI PRIVATE UTILIZZATE DALLA CLASSE
'**************************************************************************

'* Dato Percorso inserisce in fileName il nome del file e in filePath la cartella del file.
Public Sub fileNamePath(Percorso As String, Optional ByRef fileName As String, Optional ByRef filePath As String)
Dim posSlesh As Integer
    posSlesh = InStrRev(Percorso, "\")
    If posSlesh = 0 Then posSlesh = InStrRev(Percorso, "/")
    
    fileName = Right(Percorso, Len(Percorso) - posSlesh)
    filePath = Left(Percorso, posSlesh)
End Sub

'* Restituisce la cartella in cui  contenuto il file il cui percorso completo  fileName.
Public Function getFilePath(fileName As String) As String
Dim temp As String
    Call fileNamePath(fileName, , temp)
    getFilePath = temp
End Function


